//
// Copyright (c) 2012, MindFusion LLC - Bulgaria.
//

using System;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;

using MindFusion.Diagramming;
using MindFusion.Diagramming.Layout;


namespace MindFusion.Diagramming.WinForms.Samples.CS.Tutorial2
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			diagram.BackBrush = new MindFusion.Drawing.SolidBrush(Color.White);
			diagram.LinkHeadShapeSize = 3;
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			ShapeNode root = diagram.Factory.CreateShapeNode(nodeBounds);
            root.Brush = new MindFusion.Drawing.SolidBrush(Color.FromArgb(224, 233, 233));
			root.Text = "Project";
			XmlDocument document = new XmlDocument();
			document.Load("SampleTree.xml");
			CreateChildren(root, document.SelectSingleNode("Project"));

			TreeLayout layout = new TreeLayout();
			layout.Type = TreeLayoutType.Cascading;
			layout.Direction = TreeLayoutDirections.LeftToRight;
			layout.LinkStyle = TreeLayoutLinkType.Cascading2;
			layout.NodeDistance = 3;
			layout.LevelDistance = -8; // let horizontal positions overlap
			layout.Arrange(diagram);
		}

		private void CreateChildren(DiagramNode parentDiagNode, XmlNode parentXmlNode)
		{
			foreach (XmlElement element in parentXmlNode.SelectNodes("Activity"))
			{
				ShapeNode node = diagram.Factory.CreateShapeNode(nodeBounds);
                node.Brush = new MindFusion.Drawing.SolidBrush(Color.FromArgb(224, 233, 233));
                node.Text = element.GetAttribute("Name");
				diagram.Factory.CreateDiagramLink(parentDiagNode, node);
				CreateChildren(node, element);
			}
		}


		RectangleF nodeBounds = new RectangleF(0, 0, 24, 6);
	}
}